Compare commits

...

13 commits

Author SHA1 Message Date
Ohio2
fad2ddd2c3
Ok DONE 2021-10-03 00:15:40 +02:00
Ohio2
41d1ff0628
I Think APS 0.1.0 is done:
Features:
		- SHA Sums
		- PKG_FIND
2021-10-03 00:06:11 +02:00
Ohio2
a713b01352
Move old aps to a stash 2021-10-01 23:05:19 +02:00
Ohio2
46cdedc6a2
rewrite verifiaction to include only sha, rewrite sources 2021-10-01 22:40:05 +02:00
Ohio2
95d746acf1
Introduce GPG siging 2021-10-01 21:27:07 +02:00
Ohio2
2b97b44e16
Introduce GPG siging 2021-10-01 21:24:56 +02:00
Ohio2
bbd1bec527 Last pre-release snapshot (20:35.01.10.2021 eu/pl) 2021-10-01 20:35:40 +02:00
Ohio2
19838ae794 SHA256, MD5 sum verification added. 2021-10-01 20:25:48 +02:00
Ohio2
5bb6f377a4 snapshot 01.10.2021: 2021-10-01 15:58:46 +02:00
Ohio2
28b70404cb snapshot 30.09.2021 2021-09-30 19:35:13 +02:00
Ohio2
46de0ea716 Add sources support 2021-09-30 16:26:01 +02:00
Ohio2
38614d26f4 devel init 2021-09-29 16:33:24 +02:00
Ohio2
06bba6f68f 0.1.0 BETA
0.1.0 is a complete rewrite @hippoz, @hippoz it is supposed to clean up
  aps. :trol:
2021-09-29 15:48:11 +02:00
14 changed files with 301 additions and 147 deletions

View file

@ -1,5 +1,3 @@
# aps
# APS
APS - Alnux Packaging System
the alnux package manager
(the code is completely and utterly horrible and i cant believe i actually wrote this lol)

2
altools/README.md Normal file
View file

@ -0,0 +1,2 @@
# This follows the UNIX philosophy
Actually, also altools is meant to be in shell since it's ok

32
altools/alinitsys Executable file
View file

@ -0,0 +1,32 @@
#!/bin/sh
#############
# ALINITSYS #
#############
# ALINITSYS is a passthrough to RUNIT OR OPENRC, if RUNIT OR OPENRC exists, if not, then ALINITSYS will wrap it up and init the system.
function init(){
exec runit && echo ":: Running Runit..." || echo ":: Runit not found..." ;
exec openrc && echo ":: Running OpenRC..." || echo ":: OpenRC not found..." ;
echo ":: Running alinitsys"
}
function rescue(){
echo "[E] Something might've went wrong..."
echo ":: Dropping into the SH"
exec sh
}
function daemon(){
/var/service/*/start
}
function getty(){
echo ":: Getting TTY"
exec getty || exec stty
}
function start(){
init ||
daemon &&
getty ||
rescue
}
start

5
altools/c/Makefile Normal file
View file

@ -0,0 +1,5 @@
ccflags = -O3
compile:
gcc $(ccflags) pow.c -o pow
clean:
rm pow

BIN
altools/c/pow Executable file

Binary file not shown.

28
altools/c/pow.c Normal file
View file

@ -0,0 +1,28 @@
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/reboot.h>
int main (int argc, char *argv[]) {
if (geteuid() != 0) {
printf("[E] pow must be run as root\n");
return 1;
}
sync();
switch (argv[1] ? argv[1][0]: 0) {
case 's':
case 'p':
reboot(RB_POWER_OFF);
return 0;
case 'r':
reboot(RB_AUTOBOOT);
return 0;
default:
printf("pow r[eboot]|p[oweroff]|s[hutdown]\n");
return 1;
}
}

0
altools/chroot-al Normal file
View file

18
altools/dae Executable file
View file

@ -0,0 +1,18 @@
#!/bin/sh
###########################
# DAE, the deamon manager #
###########################
function daemonctl(){
case $1 in
stop) . /etc/al/serivces/$2.alsysd
stop ;;
start) . /etc/al/services/$2.alsysd
start ;;
esac
case $2 in
--verbose) set -x ;;
*) ;;
esac
}

13
altools/mkinitramfs Executable file
View file

@ -0,0 +1,13 @@
#!/bin/sh
###############
# MKINITRAMFS #
###############
if [ ! -d /usr/src/initramfs ]; then
mkdir -p /usr/src/initramfs/{bin,dev,etc,lib,lib64,mnt/root,proc,root,sbin,sys}
cp --archive /dev/{null,console,tty,sd*} /usr/src/initramfs/dev/
cp --archive /bin/busybox /usr/src/initramfs/bin/busybox
fi
cd /usr/src/initramfs
find . -print0 | cpio --null --create --verbose --format=newc | gzip --best > /boot/initramfs.cpio.gz

BIN
altools/pow Executable file

Binary file not shown.

View file

@ -6,13 +6,13 @@
. /etc/al/config
case $1 in
# add a repo
add) git clone https://${3}/${2}.git ${install_root}/var/aps/repos/${2}
add) git clone ${2} ${install_root}/var/db/repos
echo "${2}" >> ${install_root}/etc/al/repo.conf
;;
# update a repo
update) pushd && cd ${install_root}/var/aps/repos/${2} && git pull && popd ;;
# destroy a repo (remove)
destroy) rm -rfv ${install_root}/var/aps/repos/${2}
destroy) rm -rfv ${install_root}/var/db/aps/repos/${2}
sed -i "/^${2}/d" ${install_root}/etc/al/repo.conf
;;
esac

338
aps
View file

@ -1,150 +1,220 @@
#!/bin/sh
#################################
# Alnux Packaging System, #
# the package manager for Alnux #
#################################
if [ -f "$XDG_CONFIG_HOME/al/config" ]; then
. $XDG_CONFIG_HOME/al/config
elif [ -f "$HOME/.config/al/config" ]; then
. $HOME/.config/al/config
elif [ -f "/etc/al/config" ]; then
. /etc/al/config
else
temp_location="/var/tmp"
install_root="/var/tmp/alroot"
installed_pkg_database="${install_root}/var/aps/installed"
locpkg_database="${install_root}/var/aps/repos"
lock="${install_root}/var/aps/lock"
official="https://git.hippoz.xyz/alnux/repo"
debug=off
fi
if [ ${debug} = on ]; then
set -x
fi
die() {
echo "aps: fatal: ${1}"
rm "${lock}"
###################
# aps. rewritten. #
###################
# OHIO: aps *needs* to be rewritten, i can't add any thing else in the aps (v0.0.8.1)
# OHIO: aps is rewritten in 9/10th's so it's no longer a debug build
# OHIO: it's rewritten however it has some old code from aps (v0.0.8.1)
# KEMAL: abandon all hope, ye who enter here.
# OHIO: ^, however my code is cleaner than the mess before.
function conf_fetch(){
if [ -f "$XDG_CONFIG_HOME/al/config" ]; then
. $XDG_CONFIG_HOME/al/config
elif [ -f "$HOME/.config/al/config" ]; then
. $HOME/.config/al/config
elif [ -f "/etc/al/config" ]; then
. /etc/al/config
elif [ -f "/etc/skel/al/config" ]; then
. /etc/skel/al/config
#elif [ -f $AL_CFG ]; then
# . $AL_CFG
else
err "No config file!"
fi
}
case ${debug} in
on) set -x ;;
esac
function prn(){
echo -e "\e[34m==>\e[39m $1"
}
function wrn(){
echo -e "\e[34m==>\e[33m WARNING:\e[39m $1"
}
#function run(){
# printf '%s\n' "$*"
# "$@"
#}
function err(){
echo -e "\e[34m==>\e[31m ERROR:\e[39m $1" &&
rm ${lock} 2> /dev/null
exit 2
}
confirm(){
echo -ne "Are you sure? [Y/n] "
read prompt
if [[ ${prompt} = [nN] ]]; then
die "User said no. Exiting..."
elif [[ ${prompt} != [yY] ]]; then
die "User gave invalid input. Exiting..."
fi
conf_fetch
function notf(){
echo -e "\e[34m==>\e[36m NOTIFICATION:\e[39m $1"
}
run_package_script() {
{
if [ -x "${2}/${1}" ]; then
echo ":: Running ${1}"
#cd "${2}" || die "Could not enter package working directory. Exiting..."
function confirm(){
prn "To $1, press ENTER, to cancel, press CTRL+C"
}
#function dbg(){
# wrn "This is a debug build, that may not work!"
#}
function sources(){
#pkg_config_url=$(cat sources)
#pkg_config_archv=$(echo ${pkg_config_url} | sed 's:.*/::')
#curl -fLO ${pkg_config_url}
#mkdir --parents pkgex
#pkg_config_archv_ft=$(file --extension ${pkg_config_archv_ft})
#case $pkg_config_archv_ft in
# *.tar*) prn $(tar -xf ${pkg_config_archv} -C pkgex) ;;
# *.xz) prn $(cd pkgex && xz -d ../${pkg_config_archv} && cd ..) ;;
# *.bz2) prn $(cd pkgex && bzip2 -d ../${pkg_config_archv} && cd ..) ;;
# *.gz) prn $(cd pkgex && gzip -d ../${pkg_config_archv} && cd ..) ;;
# *.zst) prn $(cd pkgex && zstd -dc && cd ..) ;;
# *) wrn "Not a tar! But it will be kept!"
#esac
#mkdir --parents pkgsrc
#cp -r pkgex/*/* pkgsrc
pkg_config_url=$1
pkg_config_archv=$(echo ${pkg_config_url} | sed 's:.*/::')
curl -fLO ${pkg_config_url}
mkdir --parents pkgex
pkg_config_archv_ft=$(file --extension ${pkg_config_archv_ft})
case $pkg_config_archv_ft in
*.tar*) prn $(tar -xf ${pkg_config_archv} -C pkgex) ;;
*.xz) prn $(cd pkgex && xz -d ../${pkg_config_archv} && cd ..) ;;
*.bz2) prn $(cd pkgex && bzip2 -d ../${pkg_config_archv} && cd ..) ;;
*.gz) prn $(cd pkgex && gzip -d ../${pkg_config_archv} && cd ..) ;;
*.zst) prn $(cd pkgex && zstd -dc && cd ..) ;;
*) wrn "Not a tar! But it will be kept!"
esac
mkdir --parents pkgsrc
cp -r pkgex/*/* pkgsrc
}
function sha256(){
#sha256sum $sum > $1.sha256sum
sha256sum -c "$1" 1>&2 /dev/null
if [ "$?" -ne "0" ]; then
prn "OK!"
else
err "Sha failed!"
fi
}
#function md5(){
# sum="$(cat $@/sums)"
# md5sum "$sum"
#}
#function versum(){
# sumrest=$(cat $@/sums | cut -d'+' -f-)
# sumtype=$(cat $@/sums | cut -d'+' -f2)
# case $sumtype in
# sha256) sha256 "$1.sha256sum" ;;
# md5) err "MD5 is not supported." ;;
# esac
#}
function runbuildsh(){
if [ -x "${2}/${1}" ]; then
prn "Running $1"
cd "${2}" || err "Running $1 has failed, check your permissions."
"${2}/${1}" "${2}/payload" "${2}"
fi
}
fi
}
install_local_package() {
[ ! -e "${1}" ] && die "File ${1} does not exist. Exiting..."
# Extract the package
confirm
echo ":: Installing package ${1}"
function pkg_find(){
# i could not even bother, i had to copy kiss in some sense
set -- "$1" "$2" "$3" "${4:-"$AL_REPO"}"
IFS=:
for _find_path in $4 "${3:-$sys_db}"; do set +f
for _find_pkg in "$_find_path/"$1; do
test "${3:--d}" "$_find_pkg" && set -f -- "$@" "$_find_pkg"
done
done
unset IFS
# alnux search i guess
#case $2-$# in
# *-4) return 1 ;;
# -*) repo_dir=$5; repo_name=${5##*/} ;;
# *) shift 4; printf '%s\n' "$@"
#esac
}
function pkg_local(){
if [ -z "$AL_REPO" ]; then
err "Alnux Repo variable is not set. Will not continue"
fi
pkg_find $1
cp -prv "${1}" "${temp_location}"
# - - - - - #
# VARIABLES #
# - - - - - #
pkg_name="${1%/}"
pkg_name="${pkg_name##*/}"
pkg_name=$(echo "${pkg_name}" | cut -f 1 -d '.')
pkg_path="${temp_location}/${pkg_name}"
cd "${pkg_path}" || die "Could not enter package path."
# Set default values for package
pkg_config_deploy=true
pkg_config_ver="0"
pkg_config_makedepends=""
pkg_config_depends=""
# Download sources.
if [ -f sources ]; then
pkg_config_sources=$(cat sources)
pkg_config_sources_to=$(echo ${pkg_config_sources} | sed 's:.*/::')
curl -# ${pkg_config_sources} -o ${pkg_config_sources_to}
mkdir pkg_bd
tar -xf 1 ${pkg_config_sources_to} -C ${pkg_path}
fi
# Install package
# - - #
# #
# - - #
mkdir -p "${pkg_path}/payload"
. "${pkg_path}/package"
cd pkg_bd/
run_package_script "build" "${pkg_path}"
cd ../..
run_package_script "predeploy" "${pkg_path}"
cd "${pkg_path}"
if [ -f *.sources ]; then
sources $(cat sources)
#"$(cat *.sources)"
fi
if [ -f *.sha256sums ]; then
sha256 "*.sha256sum}"
else
wrn "No sums file(s) found! Be careful!"
fi
runbuildsh "build" "${pkg_path}/pkgsrc"
runbuildsh "predeploy" "${pkg_path}/pkgsrc"
# Old APS code from before the rewrite!
# Deploy package
if [ "${pkg_config_deploy}" = true ]; then
echo ":: Deploying target ${pkg_name}..."
prn "Deploying target ${pkg_name}..."
cp -rpv "${pkg_path}/payload"/* "${install_root}" > "${temp_location}/${pkg_name}-payloaddeploylog"
sed 's/^.*-> //' "${temp_location}/${pkg_name}-payloaddeploylog" | tr -d \'\" > "${temp_location}/${pkg_name}-payloadfiles"
rm "${temp_location}/${pkg_name}-payloaddeploylog"
fi
run_package_script "postdeploy" "${pkg_path}"
# Add package to database
runbuildsh "postdeploy" "${pkg_path}/pkgsrc"
# Yet more old APS code
if [ -x "${pkg_path}/package" ]; then
echo ":: Adding target ${pkg_name} to installed package database..."
[ ! -d "${installed_pkg_database}/${pkg_name}" ] && mkdir "${installed_pkg_database}/${pkg_name}"
prn "Adding target ${pkg_name} to installed package database..."
[ ! -d "${installed_pkg_database}/${pkg_name}" ] && mkdir -p "${installed_pkg_database}/${pkg_name}"
cp -pv "${pkg_path}/package" "${installed_pkg_database}/${pkg_name}/package"
[ -e "${temp_location}/${pkg_name}-payloadfiles" ] && cp -pv "${temp_location}/${pkg_name}-payloadfiles" "${installed_pkg_database}/${pkg_name}/payloadfiles"
else
die "Target ${pkg_name} does not have a package script (it's an invalid package!). Exiting..."
err "Target ${pkg_name} does not have a package script (it's an invalid package!). Exiting..."
fi
# Cleanup
# Old Cleanup, might work
rm -r "${pkg_path}"
rm "${temp_location}/${pkg_name}-payloadfiles"
cd "${install_root}" || die "Could not return to main directory. Exiting..."
cd "${install_root}" || err "Could not return to main directory. Exiting..."
unset pkg_path
unset pkg_name
unset pkg_config_deploy
unset pkg_config_ver
unset pkg_config_makedepends
unset pkg_config_depends
echo "[*] Install complete for package ${pkg_name}"
}
sync_deps(){
confirm
echo ":: Syncing dependencies for ${1}"
install_package_from_repo "${pkg_makedepends}"
install_package_from_repo "${pkg_deps}"
echo "[*] Install dependencies for ${1}"
}
remove_local_package() {
confirm
echo ":: Removing target ${1}..."
pkg_path="${installed_pkg_database}/${1}"
[ ! -d "${pkg_path}" ] && die "Package could not be found in local installed package database. Exiting..."
payloadfiles_path="${pkg_path}/payloadfiles"
[ ! -e "${payloadfiles_path}" ] && die "[E] Package ${1} does not have a payloadfiles file. Exiting..."
rm -rv "$(cat ${payloadfiles_path})"
rm -rv "${pkg_path}"
echo "[*] Removal complete for target ${pkg_name}"
prn "Install complete for package ${pkg_name}"
}
sync_local_repo_database() {
echo ":: Syncing local database for repo ${1}"
# Local database for repo already exists - sync it
#cd "${1}" || err "Could not enter local database directory. Exiting..."
#git pull
prn "Syncing local database for $1"
if [ ! -d "${locpkg_database}/${1}" ]; then
# Local database for repo doesnt exists - clone it
git clone "${2}" "${locpkg_database}/${1}"
else
# Local database for repo already exists - sync it
cd "${locpkg_database}/${1}" || die "Could not enter local database directory. Exiting..."
cd "${locpkg_database}/${1}" || err "Could not enter local database directory. Exiting..."
git pull
fi
}
install_package_from_repo() { # NOTE(hippoz): This can get a tad confusing... ${1} is the repo and ${2} is the package
echo ":: Installing package ${2} from ${1} repo"
[ ! -d "${locpkg_database}/${1}/${2}" ] && die "Target not found."
install_local_package "${locpkg_database}/${1}/${2}"
prn "Installing package(s) ${2} from ${1} repo"
[ ! -d "${locpkg_database}/${1}/${2}" ] && err "Target not found."
pkg_local "${locpkg_database}/${1}/${2}"
}
upgrade() {
confirm
echo ":: Upgrading installed packages"
cd "${installed_pkg_database}" || die "Could not enter local installed package database directory. Exiting..."
update() {
prn "Upgrading installed packages"
cd "${installed_pkg_database}" || err "Could not enter local installed package database directory. Exiting..."
for pkg in */; do
installed_pkg_path="${installed_pkg_database}/${pkg}"
. "${installed_pkg_path}/package"
@ -163,46 +233,34 @@ upgrade() {
unset pkg_config_depends
done
}
version(){
echo "Alnux APS v0.0.8.1"
function help(){
prn "h|help) prints this message"
prn "v|version) version"
prn "s|sync) install package(s), and sync repositories"
prn "u|update) update"
prn "i|install) install LOCAL package(s)"
}
help(){
echo "Alnux APS, the packaging system for Alnux."
echo ""
echo "sync - Synchronizes from package repository."
echo "install - Installs from local package information file and build file."
echo "upgrade - Upgrades from package repository."
echo "remove - Removes a package from /var/aps/installed and it's install files (payloadfiles)."
echo "list - Lists currently installed packages."
echo "help - Display this message."
echo "version - Display the version."
function version(){
prn "APS Version 0.1.0"
}
list(){
ls ${installed_pkg_database} | sed 's/^README.md//g'
}
main() {
if [ -f "${lock}" ]; then
echo "A lock file already exists (another instance of the package manager could be running). If you're sure no package manager is running, remove the file ${lock}."
exit 1
fi
touch "${lock}"
case ${1} in
install) install_local_package "${2}" ;;
remove) remove_local_package "${2}" ;;
#sync-dep)
# sync_local_repo_database "official" ${official}
# [ -z "${2}" ] && exit 0
# install_package_from_repo "official" "${2}" ;;
sync)
sync_local_repo_database "official" ${official}
function main(){
#if [ -f "${lock}" ]; then
# err "A lock file already exists (another instance of the package manager could be running). If you're sure no package manager is running, remove the file ${lock}."
#fi
#touch "${lock}"
#dbg
case $1 in
s|sync) sync_local_repo_database "${official}" ${official}
[ -z "${2}" ] && exit 0
install_package_from_repo "official" "${2}" ;;
upgrade) upgrade "official" ;;
help) help ;;
version) version ;;
list) list ;;
*) die "Invalid option ${1}, exiting..." ;;
install_package_from_repo "${official}" "${2}" ;;
#confirm "install" ;;
i|install) pkg_local ${*: -1} ;;
# confirm "install" ;;
u|update) update ;;
# confirm "update" ;;
v|version) version ;;
h|help) help ;;
*) err "Invalid option"
esac
rm "${lock}"
}
main "${1}" "${2}"
main $1 ${@: -1}

View file

@ -4,7 +4,7 @@
# Alnux Packaging System #
##########################
temp_location="/var/tmp"
install_root="/"
install_root="/var/tmp/alroot"
installed_pkg_database="${install_root}/var/aps/installed"
locpkg_database="${install_root}/var/aps/repos"
lock="${install_root}/var/aps/lock"

Binary file not shown.